/*____________________________________________________________________________
	Copyright (C) 2000 Networks Associates Technology, Inc.
	All rights reserved.

	$Id$
____________________________________________________________________________*/
#ifndef Included_PGPmoz_h	/* [ */
#define Included_PGPmoz_h

#define PGPMOZ_VERSION	1

typedef enum _PGPmozError
{
	PGPmoz_NoError = 0,
	PGPmoz_UnknownError,
	PGPmoz_PGPError,
	PGPmoz_PlatformNotSupported,
	PGPmoz_UserCancelled,
	PGPmoz_VersionNotSupported,
	PGPmoz_BadParameters,
	PGPmoz_OutOfMemory,
	
	PGPmoz_NumErrors
}
PGPmozError;

typedef enum _PGPmozEncryptSignFlags
{
	PGPmozEncryptSign_None		= 0x00,

	PGPmozEncryptSign_Encrypt	= 0x01,
	PGPmozEncryptSign_Sign		= 0x02,
	PGPmozEncryptSign_PGPMIME	= 0x04,

	PGPmozEncryptSign_All		= 0xFF
}
PGPmozEncryptSignFlags;

typedef struct _PGPmozContext PGPmozContext;
typedef PGPmozContext * PGPmozRef;

typedef struct _PGPmozMsgHeader
{
	char *			szTo;
	char *			szCc;
	char *			szBcc;
}
PGPmozMsgHeader;

typedef struct _PGPmozMsgBody
{
	char *	szBody;
}
PGPmozMsgBody;

/* 

Exported functions
==================

PGPmozError PGPmozInit(unsigned int nVersion, PGPmozRef *mozRef)

PGPmozError PGPmozCleanup(PGPmozRef mozRef)

PGPmozError PGPmozEncryptSign(PGPmozRef mozRef, void *pUserValue, 
							  PGPmozEncryptSignFlags nFlags, 
							  PGPmozMsgHeader *pHeader, PGPmozMsgBody *pBody, 
							  PGPmozMsgBody **pNewBody)

PGPmozError PGPmozDecryptVerify(PGPmozRef mozRef, void *pUserValue, 
                                PGPmozMsgBody *pBody, 
								PGPmozMsgBody **pNewBody)

PGPmozError PGPmozFreeMsgBody(PGPmozRef mozRef, PGPmozMsgBody *pBody)

*/

typedef PGPmozError (* PGPmozInitProc)(unsigned int, PGPmozRef *);

typedef PGPmozError (* PGPmozCleanupProc)(PGPmozRef);

typedef PGPmozError (* PGPmozEncryptSignProc)(PGPmozRef, void *,
											  PGPmozEncryptSignFlags, 
											  PGPmozMsgHeader *, 
											  PGPmozMsgBody *, 
											  PGPmozMsgBody **);

typedef PGPmozError (* PGPmozDecryptVerifyProc)(PGPmozRef, void *,
												PGPmozMsgBody *, 
												PGPmozMsgBody **);

typedef PGPmozError (* PGPmozFreeMsgBodyProc)(PGPmozRef, PGPmozMsgBody *);

#endif /* ] Included_PGPmoz_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
