/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 */
 
#ifndef nsIPGPModule_h_
#define nsIPGPModule_h_

#include "prtypes.h"

// {633C38A0-ED73-11d4-AD84-00010234518F}
#define NS_IPGP_MODULE_IID \
  { 0x633c38a0, 0xed73, 0x11d4, \
  { 0xad, 0x84, 0x0, 0x1, 0x2, 0x34, 0x51, 0x8f } };

class nsIPGPModule : public nsISupports {
public: 
  static const nsIID& GetIID() { static nsIID iid = NS_IPGP_MODULE_IID; return iid; }

  NS_IMETHOD  SetEncrypt(PRBool encrypt, int *flags) = 0;

  NS_IMETHOD  SetSign(PRBool sign, int *flags) = 0;

  NS_IMETHOD  SetPGPMIME(PRBool mime, int *flags) = 0;

  NS_IMETHOD  CreateMsgHeader(char *to, char *cc, char *bcc, 
              void **msg_header) = 0;

  NS_IMETHOD  CreateMsgBody(char *body, void **msg_body) = 0;

  NS_IMETHOD  GetStringFromMsgBody(void *msg_body, char **string) = 0;

  NS_IMETHOD  EncryptSign(void *user_value, int flags, void *msg_header,
              void *orig_body, void **new_body) = 0;

  NS_IMETHOD  DecryptVerify(void *user_value, void *orig_body, 
              void **new_body) = 0;

  NS_IMETHOD  FreeMsgHeader(void *msg_header) = 0;

  NS_IMETHOD  FreeMsgBody(void *msg_body) = 0;

  NS_IMETHOD  FindHeader(char *header_buffer, char *header_str,
              char **header_start, int *header_length, 
              char **buffer_end) = 0;
}; 

#endif /* nsIPGPModule_h_ */
