/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): 
 */
 
#ifndef nsPGPModule_h_
#define nsPGPModule_h_

#include "nsISupports.h"
#include "prtypes.h"
#include "nsIPGPModule.h"

// {633C38A1-ED73-11d4-AD84-00010234518F}
#define NS_PGP_MODULE_CID \
  { 0x633c38a1, 0xed73, 0x11d4, \
  { 0xad, 0x84, 0x0, 0x1, 0x2, 0x34, 0x51, 0x8f } }

#define NS_PGP_MULTSIGNED_CONTENT_TYPE_HANDLER_NAME \
  "MIME PGP Multipart Signed Handler"

#define NS_PGP_MULTSIGNED_CONTENT_TYPE_HANDLER_CONTRACTID \
  "@mozilla.org/mimecth;1?type=multipart/signed"

#define NS_PGP_MULTENCRYPTED_CONTENT_TYPE_HANDLER_NAME \
  "MIME PGP Multipart Encrypted Handler"

#define NS_PGP_MULTENCRYPTED_CONTENT_TYPE_HANDLER_CONTRACTID \
  "@mozilla.org/mimecth;1?type=multipart/encrypted"

#define NS_PGP_PLAINTEXT_CONTENT_TYPE_HANDLER_NAME \
  "MIME PGP Plain Text Handler"

#define NS_PGP_PLAINTEXT_CONTENT_TYPE_HANDLER_CONTRACTID \
  "@mozilla.org/mimecth;1?type=text/plain"

typedef struct _PGPvtbl PGPvtbl;

class nsPGPModule : public nsIPGPModule {
public: 
  nsPGPModule();
  virtual ~nsPGPModule();
       
  /* this macro defines QueryInterface, AddRef and Release for this class */
  NS_DECL_ISUPPORTS 

  NS_IMETHOD  SetEncrypt(PRBool encrypt, int *flags);

  NS_IMETHOD  SetSign(PRBool sign, int *flags);

  NS_IMETHOD  SetPGPMIME(PRBool mime, int *flags);

  NS_IMETHOD  CreateMsgHeader(char *to, char *cc, char *bcc, 
              void **msg_header);

  NS_IMETHOD  CreateMsgBody(char *body, void **msg_body);

  NS_IMETHOD  GetStringFromMsgBody(void *msg_body, char **string);

  NS_IMETHOD  EncryptSign(void *user_value, int flags, void *msg_header,
              void *orig_body, void **new_body);

  NS_IMETHOD  DecryptVerify(void *user_value, void *orig_body, 
              void **new_body);

  NS_IMETHOD  FreeMsgHeader(void *msg_header);

  NS_IMETHOD  FreeMsgBody(void *msg_body);

  NS_IMETHOD  FindHeader(char *header_buffer, char *header_str,
              char **header_start, int *header_length, 
              char **buffer_end);

private:
  PGPvtbl * vtbl;
  void *    module_object;
  void *    library_object;
}; 

#endif /* nsPGPModule_h_ */
